CSECT   SCEPTRE1
cloli       modified exec1.f and cesct present
cloli       22/06/08      TIODAY changed from character*8 to character*10 
cloli       unused labels 89 81 eliminated
cloli       opening of files moved to open1.f
cloli       closing of files eliminated
cloli       calling to datack adapted to new datack.f (1/1)
cloli       processing RE-OUTPUT eliminated 

C       S C E P T R E
C       copyright 1990-2006 by WRNovender

       PROGRAM  S C E P T R E 1
 
C      MODE INDICATOR SETTINGS           MODIND
C             1 - MODEL DESCRIPTION
C             2 - CIRCUIT DESCRIPTION
C             3 - CONTINUE
C             4 - OUTPUT
C             5 - RERUN DESCRIPTION
C             6 - END
C             7 - RELOAD SIMUL8
 
      IMPLICIT DOUBLE PRECISION (A - H, O - Z), INTEGER (I - N)
 
      include 'tapes.inc'

      COMMON /CNTRLS/ ICNTRL(99),IERROR,ICVCEQ,IMISS,XLTNOD
      COMMON /SAVER/  EW,NEWGRP,ISTSAV,ILTSAV,JSKIP,SAVE(72)
      COMMON /BUFERS/ BUFFER(10)
         CHARACTER*8  BUFFER
      DIMENSION CNTRL(160)
        EQUIVALENCE (CNTRL(1),ICNTRL(1)),(XGEAR,CNTRL(54))
        EQUIVALENCE (CNTRL(55),XTRNIC),(CNTRL(61),XDIFF)
      CHARACTER*8 ENDATA(4)
      CHARACTER*8 EXC1
      CHARACTER TIODAY*10, DATO*10, wdcomp*36
      INTEGER TAPE
      DATA ENDATA /'CSECT   ','*00000  ','      EN','D       '/
      DATA EXC1   /'sceptre1'/
      include 'compiled.inc'
c     open input files and  output files for sceptre1; or stop
      call open1
      call present
      CALL QQQDTE (DATO)
      CALL QQQCLK (TIODAY) 
      WRITE (iqqout,99) DATO,TIODAY
 99   FORMAT(1H1,' PROCESSING INPUT FILE   ',A,' - ',A,//)
      JSKIP=1
      NEWGRP=1
      IEND=1
 
C     GET A CARD FROM INPUT TAPE
    1 CALL GETCK(ISTART,LASTCR,NOCARD)
      IF(NEWGRP.GE.0) GO TO 37
      MODIND=IABS(NEWGRP)
      TAPE=iqqpgm
      GO TO (38,40,45,50,83,83,60), MODIND
   37 CALL ERROR (EXC1,1,27 )
      GO TO 1
 
C     ENTER MODEL PROCESSOR
 
   38 CALL MDEDIT (MODIND,LASTCR)
      GO TO (83,40,45,50,83,85 ),MODIND
 
C     ENTER CIRCUIT DESCRIPTION PROCESSOR
 
   40 CALL CDPRS (MODIND,NRERUN)

C     ENTER DATA CHECK ROUTINE
 
c     CALL DATACK (MODIND)
      CALL DATACK 

C     ENTER TOPOLOGY PROCESSOR
 
      IF(nint(XLTNOD).EQ.1) CALL TOPLGY
      IF(MODIND.LE.4) GO TO 83
      IF(IERROR.NE.1) GO TO 42
 
C     ENTER PROGRAM GENERATOR
      CALL GENER8 (IERROR,NELMTS)
C     ENTER DATA GENERATOR - RERUN PROCESSOR
 
   42 CONTINUE
      IF (IERROR.GT.1) THEN
         WRITE(iqqout,
     *   '(''0SIMULATION ABORTED DUE TO SEVERITY LEVEL'',I3)') IERROR
         ismg=1
         goto 900 
      END IF
      
      CALL RRPRO (MODIND,NRERUN)
      IF(MODIND.EQ.4) GO TO 110
      GO TO 80
 
C     ENTER CONTINUE PROCESSOR
 
   45 CALL CNTNU
      GO TO 110
 
C     ENTER RE-OUTPUT PROCESSOR
 
cloli   50 CALL XOTPR
cloli      GO TO 42
cloli  50  write (iqqout,55)
   50 call error('',4,107)   
cloli      go to 85
 
C     LOAD SIMUL8 PROGRAM AND SIMUL8 DATA ON ISAVTP
   60 READ (iqqinp,65) BUFFER
   65 FORMAT (10A8)
      GO TO (68,66,69),IEND
   66 IF(BUFFER(1).EQ.ENDATA(1)) GO TO 67
      IEND=4
      REWIND TAPE
      TAPE=iqqdat
   67 IEND =IEND-1
   68 IF(BUFFER(1).EQ.ENDATA(3).AND.BUFFER(2).EQ.ENDATA(4)) IEND=2
   69 WRITE (TAPE,65) BUFFER
      IF(BUFFER(1).EQ.ENDATA(2)) GO TO 70
      GO TO 60
   70 REWIND TAPE
      GO TO 110
 
C     CHECK FOR INITIAL CONDITIONS USING VECTOR EQUATIONS
 
   80 IF(IERROR.NE.1) GO TO 85
      IF(nint(XTRNIC).NE.0) GO TO 100
      IF(ICVCEQ.EQ.0) GO TO 100
 
C     REDUCE SIMUL8 PROGRAM AND MODIFY DATA BLOCKS
 
      CALL DOLOOP(IERROR)
      IF(IERROR.NE.1) GO TO 85
 
C     GENERATE JACOBIAN FOR GEAR IF REQUIRED
 
  100 IF(nint(XGEAR).LE.0 .OR. nint(XDIFF).EQ.1) GO TO 105
      CALL JACOBN(IERROR)

      IF(IERROR.NE.1) GO TO 85
  105 CALL SPLITR(NELMTS)
  110 IF(IERROR.NE.1) GO TO 85
      
C     HAS USER REQUESTED THAT SETUP PHASE ONLY BE EXECUTED
 
      IF(nint(CNTRL(63)).EQ.1) GO TO 85
 
C     CONVERT PGMSAVE FILE FROM FORTRAN IV TO FORTRAN 77
 
      CALL XF4F77
      WRITE(iqqout,87)
   87 FORMAT('0SYSTEM NOW ENTERING SIMULATION')
      print *,'SYSTEM NOW ENTERING SIMULATION'
      stop 0

   83 WRITE (iqqout,84)
   84 FORMAT('0AN ILLEGAL PROCESSING SEQUENCE HAS BEEN REQUESTED')
      print *,'AN ILLEGAL PROCESSING SEQUENCE HAS BEEN REQUESTED'
   85 WRITE (iqqout,82)
   82 FORMAT('0SIMULATION HAS BEEN DELETED')
      ismg=2
c     All units will be closed; it is allways so

 900  if (ismg == 1) then      
         print *, 'STOP ',EXC1,': simulation aborted due to error(s)'
         STOP 101
      elseif (ismg == 2) then 
         print *,'STOP ',EXC1,': simulation deleted' 
         STOP 102
      end if

      END
C ----------------------------------------------------------------------------
csect   present
      subroutine present
      include '../auxpro/version.inc'
      include '../auxpro/version_i.inc'
      include 'tapes.inc' 
      character*79 wcopy
      data wcopy(1:39) /'distributed under the terms of the GNU '/ 
      data wcopy(40:79) /'General Public License, see file COPYING'/
      print 100,'sceptre',versn,'1990-2009 by WRNovender'
      print *,'sceptre-inenco:  ',versni,'2009-2013 by Inenco'
 100  FORMAT(1x,A,' de fecha ',F9.3,' copyright ',A)
      print * ,wcopy
      return
      end

